
function PricesMIT(K,tl,Z,TT,params::AiyagariParametersEGM) # K is here K(-1)
#before tax
    @unpack β,α,δ,γ,χ,ϕ = params
    CC = (χ*(1-tl))^ϕ
    w = (Z*(1-α)*(K/CC)^α)^(1/(1+ϕ*α))
    L = CC*(w^ϕ)
    R = α*Z*(K/L)^(α-1.0) + 1.0 - δ
      return AggVarsEGM(R,w,TT)
end




function EulerBackMIT(pol::AbstractArray,
                   Aggs::AggVarsEGM,
                   Aggs_P::AggVarsEGM, # for transitions
                   AiyagariModel::AiyagariModelEGM,
                   cpol::AbstractArray,
                   apol::AbstractArray)
    
    @unpack params,na,nd,ns,aGridl,Transv,states = AiyagariModel
    @unpack γ,β,χ,ϕ = params

    Trans = reshape(Transv,ns,ns)
    
    R_P,w_P = Aggs_P.R,Aggs_P.w
    R,w,TT = Aggs.R,Aggs.w,Aggs.TT
    
   # cp = get_cEGM(pol,Aggs_P,aGridl,AiyagariModel,cpol) #vector ns*na
    Zp  = get_ZEGM(pol,Aggs_P,aGridl,AiyagariModel,cpol) #vector ns*na, future prices    
   # Zp = max.(Zp,0.001)   # may be negative in the iteration
    
    upcp = uPrime(Zp,γ)
    Eupcp = copy(cpol)
   
 X = ((χ*Aggs.w .*states).^(1+ ϕ))/χ
    
 for ai = 1:na
     for si = 1:ns
         asi = (si-1)*na + ai
         Eupcp_sp = 0.0
         for spi = 1:ns
             aspi = (spi-1)*na + ai
#               Eupcp_sp += Trans[spi,si]*upcp[aspi]*R_P
             Eupcp_sp += Trans[spi,si]*upcp[aspi] 
         end
         Eupcp[asi] = Eupcp_sp 
     end
 end

    upc = β*Eupcp*R_P #OK next period price    
    c = copy(upc)
    Z = uPrimeInv(upc,γ)

    for ai = 1:na
        for si = 1:ns
            asi = (si-1)*na+ai
#            apol[asi] = (aGridl[asi] + c[asi] - w*states[si])/R
            c[asi]    = Z[asi] + X[si]*ϕ/(1+ϕ)
            apol[asi] = (aGridl[asi] + c[asi] - TT- X[si])/R                  
        end
    end

    return apol,c,upc
end

    


function MakeTransMatMIT(pol,AiyagariModel,tmat)
    @unpack ns,na,aGrid,Transv = AiyagariModel
    pol = reshape(pol,na,ns)
    
    Trans = reshape(Transv,ns,ns)
    tmat = copy(tmat)
    tmat  .=0.0

    for a_i = 1:na
        for j = 1:ns
            x,i = interpEGM(pol[:,j],aGrid,aGrid[a_i],na)
            p = (aGrid[a_i] - pol[i,j])/(pol[i+1,j] - pol[i,j])
            p = min(max(p,0.0),1.0)
            sj = (j-1)*na
            for k = 1:ns
                sk = (k-1)*na
                tmat[sk+i+1,sj+a_i] = p * Trans[k,j]
                tmat[sk+i,sj+a_i] = (1.0-p) * Trans[k,j]
            end
        end
    end
   
    return tmat
end


function UpdateAggs(
    initialpol::AbstractArray,
    initialdis::AbstractArray,
    Kguess::AbstractArray,
    Zpath::AbstractArray,
    AiyagariModel::AiyagariModelEGM,  
    tk::Real,
    tl::Real,
    TT::Real,
    tol = 1e-10,maxn = 50)

    @unpack params,aGridl,na,nd,ns = AiyagariModel

    TimePeriods = length(Kguess)
    tmat = zeros(eltype(initialpol),(na*ns,na*ns)) # HERE
    cmat = zeros(eltype(initialpol),na*ns)
    cmat2 = zeros(eltype(initialpol),na*ns)
    apols = zeros(eltype(initialpol),na*ns,TimePeriods)
    devol = zeros(eltype(initialpol),na*ns,TimePeriods)
    aggK  = zeros(TimePeriods)
    DIFF  = zeros(TimePeriods)
    
    ##Find policies back through time
    pol = initialpol
    apols[:,TimePeriods] = pol


    for i = TimePeriods:-1:2
        #println("time: ",i-1)
        K,Z_P = Kguess[i],Zpath[i] # K[i] est le capital productif à la période i, c'est donc K(t-1)
        K_m,Z = Kguess[i-1],Zpath[i-1]
         Se    = 1.0  # not time-varying unemployment
         Se_P  = 1.0
  #      f_P   = σf*(Zpath[i]-1)+findss
  #      f     = σf*(Zpath[i-1]-1)+findss # between i-1 and i
        Pr_P  = PricesMIT(K,tl,Z_P,TT,params) #tomorrow
        Pr    = PricesMIT(K_m,tl,Z,TT,params)  #today
        cmat  = zeros(eltype(initialpol),na*ns)
        cmat2 = zeros(eltype(initialpol),na*ns)
        pol2   = EulerBackMIT(pol,Pr,Pr_P,AiyagariModel,cmat,cmat2)[1]
        #pol = SolveIndProblem(pol,Pr,MitModel,cmat,cmat)
        apols[:,i-1] = pol2 #apols[:,i] is thus between i and i+1
        pol = pol2
    end


    
    #@show apols
    ###Find Evolution of distribution
    #first period policy rule  unchanged but distribution changed (increase in labour finding rate)
    dis = initialdis
    trans = MakeTransMatMIT(initialpol,AiyagariModel,tmat)    
    dis = trans*dis
    DIFF[1] = sum(dis[Int(end/2+1):end])
    aggK[1] = dot(aGridl,dis)
    devol[:,1] = dis
    for i = 1:TimePeriods-1  # construction distribution at period i+1
        
        #println("time: ",i)
        pol = apols[:,i] ###check on this, I think it was wrong
        tmat .= 0.0
        trans = MakeTransMatMIT(pol,AiyagariModel,tmat)
        dis = trans*dis
        aggK[i+1] = dot(aGridl,dis) # c'est donc K(t)
        devol[:,i+1] = dis
        DIFF[i+1] = sum(dis[(na*ns+1):end]) 
    end
        
    return apols,devol,aggK,DIFF
end

function equilibrium(Kguess,Zpath,initialpol,initialdis,AiyagariModel, TT,tk,tl,tol = 1e-6,maxn = 50)

    pol_ss,dis_ss = initialpol,initialdis
    aggK = copy(Kguess)
    apols,devol,aggK,DIFF = UpdateAggs(pol_ss,dis_ss,Kguess,Zpath,AiyagariModel,tk,tl,TT)
    #Kguess
    
    for i = 1:100
        #@show Kguess
        apols,devol,aggK,DIFF = UpdateAggs(pol_ss,dis_ss,Kguess,Zpath,AiyagariModel,tk,tl,TT)
        @show dif = maximum(abs.(aggK - Kguess))
        if dif < tol
            return apols,devol,aggK,DIFF
        end
        Kguess = 0.2*aggK + 0.8*Kguess
    end
    #return print("did not converge")
    return apols,devol,aggK,DIFF
end

####################################################

##############Solve aiyagari economy
## store policies, stationary distribution, and aggregate capital


#=
####################################################

K0 = 47.0
AA0,pol0,Pr0 = Model(K0)
##predefining matrices
#cMat = fill(0.0,(AA0.na*AA0.ns,))
#aMat = fill(0.0,(AA0.na*AA0.ns,))
#tMat = fill(0.0,(AA0.ns*AA0.nd,AA0.ns*AA0.nd))
pol_ss = readdlm("pol_ss.csv")
dis_ss = readdlm("dis_ss.csv")
K_ss = dot(dis_ss,AA0.aGridl)
TimePeriods = 10
OffeqPathTime = 1
### steady state productivity
z_ss = 1.0
### Create capital path guess and path of shocks
Kguess = K_ss*ones(TimePeriods+1) #add time 0
Zpath = vcat(1.01*ones(OffeqPathTime),z_ss*ones(TimePeriods+1-OffeqPathTime))
### Solve for transition path back to steady state
equilibrium(Kguess,Zpath,pol_ss,dis_ss,AA0)

#
eq_apols,eq_dpols,eq_aggKs = UpdateAggs(Kguess,Zpath,pol_ss,dis_ss,AA0) 
p1 = plot(AA0.aGrid,eq_dpols[1:AA0.na,1])
p1 = plot!(AA0.aGrid,eq_dpols[1:AA0.na,div(TimePeriods,2)])
p1 = plot!(AA0.aGrid,eq_dpols[1:AA0.na,TimePeriods])
p2 = plot(collect(0:1:TimePeriods),eq_aggKs,label="Aggregate capital path from Mit shock")
p = plot(p1,p2, layout=(1,2),size=(1000,400))
savefig(p,"MITfigures.pdf")

=#
