
function Optim(eco::Projection,params::AiyagariParametersEGM,ϵ::Real,κ::Real)
############
    
    

amin   = minimum(eco.aep./eco.Sp)
ns     = eco.ns
Nbin   = eco.Nbin
χ      = params.χ
w      = eco.w
R      = eco.R
states = eco.states
ytype  = eco.ytype
ϕ      = params.ϕ
β      = params.β
γ      = params.γ
α      = params.α
δ      = params.δ
Ucp    = vec(eco.Ucp) #not per capita
Sp     = vec(eco.Sp)
Ap     = Ucp./Sp
A      = eco.A
tauc   = A/sum(eco.aep)-1
#Ly    = vec(transpose(eco.lb*ones(1,eco.L)))
Ly     = eco.lb[ytype].*states[ytype]
Lv     = eco.lb[ytype]
TT     = eco.Agg.TT    
PI      = eco.Matab     
    

Xp     = vec(eco.cp./eco.Sp) - (1/(χ*(1+1/ϕ)))*Lv.^(1+1/ϕ) # Argument utility function
θ      = 0# eco.θ
#Xp[findall(x->x==2,2 .*isnan.(Xp))] .=1.0
uSecond(X) = (-γ).*(X.^(-γ-1))

#=
    if γ==1
    Uvv(X) = log.(X)
else
    Uvv(X) =  (X.^(1-γ)-1)./(1-γ)
end
 =#   


Uccp = (-γ).*(Xp.^(-γ-1))
UcpV = Xp.^-γ # per capita



#######################
# Pareto weights
#######################

ω = ones(1,Nbin)
       
#######################
# Constructing V1 et V2 
#######################

Sp[findall(x->x<=10^-20,Sp)] .=10^-10
Diagp = diagm(Sp)
iDiagp = diagm(1.0 ./Sp)

PIt = transpose(PI)    

#PIupc = iDiagp*eco.PIup*Diagp   
    
PIS = Diagp*transpose(PI)*iDiagp # per capita, whereas PIup is not)

#Id = Matrix{Float64}(I, ns*L, ns*L)
Id = sparse(I,Nbin,Nbin)
Bp  = diagm(eco.xsip .*Uccp)*(R*PI - Id)
Uv  = Sp .*eco.xsip .*UcpV


#PIh = Diagp*PIa*iDiagp 
#PIh = PIS    
P = sparse(I,eco.Nbin,eco.Nbin);
for i=eco.indcc
    P[i,i]=0
end
Pc = Id - P     
    
#P  = diagm(vec([ones(1,ns)-vectc;ones(L-1,ns)]))
#Pc =  diagm(ones(ns*L)-vec([ones(1,ns)-vectc;ones(L-1,ns)]))
#Ly = vec(transpose((states.*eco.lb)*ones(1,eco.L)))

M = P - β*R*P*PIS
V1 = inv(M*Bp+Pc)*P*Sp
V2 = inv(M*Bp+Pc)*M*Uv



Ltot = sum(Sp.*Ly) #it is also  L=(χ*w)^ϕ 

abc = vec(eco.abp ./ eco.Sp)# beginning-of-period per capita
abc[findall(x->x>10^30,abc)] .=0    # if size is very small
      
N1 = sum( - diagm(abc)*(Uv - Bp*V2) +  diagm(UcpV.*eco.xsip)*PI*V2)
D1 = sum(diagm(UcpV.*eco.xsip)*PI*V1 + diagm(abc)*Bp*V1)
Γ = N1/D1

Sλ = Γ*V1-V2
Sψ = Uv + Bp*Sλ
μ  = sum(Sψ)

#display(transpose(Ly)*Sψ)
#display(μ)
γ  = (( μ*Ltot - transpose(Ly)*Sψ) )/ ( ((ϵ-1)/κ)*Ltot*sum(Sp.*eco.xsip.*UcpV))

λ = Sλ./Sp    
ψ = Sψ./Sp 
λt  = iDiagp*PI*Diagp*λ 
Uvc  = eco.xsip.*UcpV

#display(sum(Ly.*Sp))

CC = zeros(Float64,6)
CC[1] = maximum(Sλ - Γ*V1 + V2) #    - (- Uvc  + diagm(eco.xsip .*Uccp)*(λ - R*λt)))
CC[2] = maximum(P*ψ - β*R*P*PIt*ψ- Γ*P*ones(Nbin,1))
CC[3] = maximum(Pc*Sλ)
CC[4] = maximum(sum(Ly.*Sp.*ψ) +((ϵ-1)/κ)*γ*Ltot*sum(Sp.*eco.xsip.*UcpV)  - μ*Ltot)
CC[5] = sum( ψ.*vec(eco.abp)) + sum(Sp.*λt.*eco.xsip.*UcpV)
CC[6] = sum(Sp.*ψ) - μ 

Pl = PlanNK(vec(λ),vec(λt),vec(ψ),vec(ω),vec(Uvc),vec(CC),μ,γ,Γ)
return Pl 
end
