##############################
#   Defining parameters  
##############################

α = 0.36
δ   = 0.025
γ = 1.0001

ϕ = .5

if γ==1.0
    Uvv(X) = log.(X)+10
    Ulinv(X) = exp.(X - 10.)
else
    Uvv(X) =  (X.^(1-γ)-1)./(1-γ) +10.
    Ulinv(X) = (1. +(1-γ).* ( X - 10.) ).^(1/(1-γ))
end


ns     = 5
na     = 100

# initial
pers = 0.9695
sigma2 = 0.0384
vary = (sigma2^2/(1-pers^2))
# changing the pesistence with same standard deviation

pers = 0.98
sigma2 = 4.6*((1-pers^2)*vary)^0.5

pers = 0.96
sigma2 = 4.02*((1-pers^2)*vary)^0.5


rho    = pers^0.25; #Persistence component of income
sige = ((sigma2*(1-pers^0.5)/(1-pers^2))^0.5)/(1+ϕ)


mc     = rouwenhorst(ns,rho,sige)
endow  = exp.(mc.state_values)
#######redifining the transition Matrix
#### I put remaining weight on the diagonal
Trans = collect(mc.p')
Trans[findall(x->x<=5*10^-5,Trans)].=0
for i =1:ns
    Trans[i,i] = Trans[i,i]+ (1 - sum(Trans,dims=1)[i])
end
#Trans  = Matrix(mc.p')

#stdist = stationary_distributions(mc)
stdist = (Trans^100000)[:,1]

Transv = vec(Trans) #  Trans = reshape(Transv,size(Trans)[1],size(Trans)[2])
amin = 1e-9
amax = 1000.0 #10000
curv = 4

#Renormalization
lbar   = dot(stdist,endow .^(1.0 + ϕ))
states = endow./ (lbar^(1/(1+ϕ)))  #I must have  s.*y^(1+phi)==1
vstan = stdist; # vector of stationary distribution

